Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_exp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 2024)
@@ -2,6 +2,6 @@
    !!==============================================================================
    !!                    ***  MODULE  trazdf_exp  ***
-   !! Ocean active tracers:  vertical component of the tracer mixing trend using
-   !!                        a split-explicit time-stepping 
+   !! Ocean  tracers:  vertical component of the tracer mixing trend using
+   !!                  a split-explicit time-stepping 
    !!==============================================================================
    !! History :  OPA  !  1990-10  (B. Blanke)  Original code
@@ -16,4 +16,5 @@
    !!             -   !  2005-11  (G. Madec)  New organisation
    !!            3.0  !  2008-04  (G. Madec)  leap-frog time stepping done in trazdf
+   !!            3.3  !  2010-06  (C. Ethe, G. Madec) Merge TRA-TRC
    !!----------------------------------------------------------------------
 
@@ -24,11 +25,8 @@
    USE oce             ! ocean dynamics and active tracers 
    USE dom_oce         ! ocean space and time domain 
-   USE domvvl          ! variablevolume levels
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE domvvl          ! variable volume levels
    USE zdf_oce         ! ocean vertical physics
    USE zdfddm          ! ocean vertical physics: double diffusion
    USE in_out_manager  ! I/O manager
-   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -49,5 +47,6 @@
 CONTAINS
 
-   SUBROUTINE tra_zdf_exp( kt, p2dt )
+   SUBROUTINE tra_zdf_exp( kt    , cdtype, p2dt, kn_zdfexp,  &
+      &                    ptrab , ptraa , kjpt              )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_zdf_exp  ***
@@ -58,7 +57,7 @@
       !! ** Method  : - The after tracer fields due to the vertical diffusion
       !!      of tracers alone is given by:
-      !!                zwx = tb + p2dt difft
-      !!      where difft = dz( avt dz(tb) ) = 1/e3t dk+1( avt/e3w dk(tb) )
-      !!           (if lk_zdfddm=T use avs on salinity instead of avt)
+      !!                zwx = ptrab + p2dt difft
+      !!      where difft = dz( avt dz(ptrab) ) = 1/e3t dk+1( avt/e3w dk(ptrab) )
+      !!           (if lk_zdfddm=T use avs on salinity and passive tracers instead of avt)
       !!      difft is evaluated with an Euler split-explit scheme using a
       !!      no flux boundary condition at both surface and bottomi boundaries.
@@ -66,18 +65,24 @@
       !!              - the after tracer fields due to the whole trend is 
       !!      obtained in leap-frog environment by :
-      !!          ta = zwx + p2dt ta
+      !!          ptraa = zwx + p2dt ptraa
       !!              - in case of variable level thickness (lk_vvl=T) the 
       !!     the leap-frog is applied on thickness weighted tracer. That is:
-      !!          ta = [ tb*e3tb + e3tn*( zwx - tb + p2dt ta ) ] / e3tn
+      !!          ptraa = [ ptrab*e3tb + e3tn*( zwx - ptrab + p2dt ptraa ) ] / e3tn
       !!
-      !! ** Action : - after tracer fields (ta,sa) 
+      !! ** Action : - after tracer fields pta
       !!---------------------------------------------------------------------
-      INTEGER , INTENT(in)                 ::   kt     ! ocean time-step index
-      REAL(wp), INTENT(in), DIMENSION(jpk) ::   p2dt   ! vertical profile of tracer time-step
-      !!
-      INTEGER  ::   ji, jj, jk, jl            ! dummy loop indices
-      REAL(wp) ::   zlavmr, zave3r, ze3tr     ! temporary scalars
-      REAL(wp) ::   zta, zsa, ze3tb           ! temporary scalars
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwx, zwy, zwz, zww   ! 3D workspace
+      !! * Arguments
+      INTEGER         , INTENT(in   )                                ::   kt          ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                                ::   cdtype      ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                                ::   kjpt        ! number of tracers
+      INTEGER         , INTENT(in   )                                ::   kn_zdfexp   ! number of sub-time step
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpk)                ::   p2dt        ! vertical profile of tracer time-step
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk,kjpt)   ::   ptrab       ! before and now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)   ::   ptraa       ! tracer trend 
+      !! * Local declarations
+      INTEGER  ::  ji, jj, jk, jn, jl        ! dummy loop indices
+      REAL(wp) ::  zlavmr, zave3r, ze3tr     ! temporary scalars
+      REAL(wp) ::  ztra, ze3tb               ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwx, zwy   ! 3D workspace
       !!---------------------------------------------------------------------
 
@@ -90,62 +95,66 @@
       ! Initializations
       ! ---------------
-      zlavmr = 1. / float( nn_zdfexp )                           ! Local constant
+      zlavmr = 1. / float( kn_zdfexp )                           ! Local constant
       !
-      zwy(:,:, 1 ) = 0.e0        ;   zww(:,:, 1 ) = 0.e0        ! surface boundary conditions: no flux
-      zwy(:,:,jpk) = 0.e0        ;   zww(:,:,jpk) = 0.e0        ! bottom  boundary conditions: no flux
       !
-      zwx(:,:,:)   = tb(:,:,:)   ;   zwz(:,:,:)   = sb(:,:,:)   ! zwx and zwz arrays set to before tracer values
+      DO jn = 1, kjpt
+         !
+         zwy(:,:, 1 ) = 0.e0     ! surface boundary conditions: no flux
+         zwy(:,:,jpk) = 0.e0     ! bottom  boundary conditions: no flux
+         !
+         zwx(:,:,:)   = ptrab(:,:,:,jn)  ! zwx array set to before tracer values
 
-      ! Split-explicit loop  (after tracer due to the vertical diffusion alone)
-      ! -------------------
-      !
-      DO jl = 1, nn_zdfexp
-         !                     ! first vertical derivative
-         DO jk = 2, jpk
-            DO jj = 2, jpjm1 
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zave3r = 1.e0 / fse3w_n(ji,jj,jk) 
-                  zwy(ji,jj,jk) =   avt(ji,jj,jk) * ( zwx(ji,jj,jk-1) - zwx(ji,jj,jk) ) * zave3r
-                  zww(ji,jj,jk) = fsavs(ji,jj,jk) * ( zwz(ji,jj,jk-1) - zwz(ji,jj,jk) ) * zave3r
+         ! Split-explicit loop  (after tracer due to the vertical diffusion alone)
+         ! -------------------
+         !
+         DO jl = 1, kn_zdfexp
+            !                     ! first vertical derivative
+            DO jk = 2, jpk
+               DO jj = 2, jpjm1 
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     zave3r = 1.e0 / fse3w_n(ji,jj,jk) 
+                     IF( cdtype == 'TRA' .AND. jn == jp_tem ) THEN  ! temperature : use of avt
+                        zwy(ji,jj,jk) =   avt(ji,jj,jk) * ( zwx(ji,jj,jk-1) - zwx(ji,jj,jk) ) * zave3r
+                     ELSE                                           ! salinity or pass. tracer : use of avs
+                        zwy(ji,jj,jk) = fsavs(ji,jj,jk) * ( zwx(ji,jj,jk-1) - zwx(ji,jj,jk) ) * zave3r
+                     END IF
+                  END DO
                END DO
             END DO
-         END DO
-         !
-         DO jk = 1, jpkm1      ! second vertical derivative   ==> tracer at kt+l*2*rdt/nn_zdfexp
-            DO jj = 2, jpjm1 
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  ze3tr = zlavmr / fse3t_n(ji,jj,jk)
-                  zwx(ji,jj,jk) = zwx(ji,jj,jk) + p2dt(jk) * ( zwy(ji,jj,jk) - zwy(ji,jj,jk+1) ) * ze3tr
-                  zwz(ji,jj,jk) = zwz(ji,jj,jk) + p2dt(jk) * ( zww(ji,jj,jk) - zww(ji,jj,jk+1) ) * ze3tr
+            !
+            DO jk = 1, jpkm1      ! second vertical derivative   ==> tracer at kt+l*2*rdt/nn_zdfexp
+               DO jj = 2, jpjm1 
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     ze3tr = zlavmr / fse3t_n(ji,jj,jk)
+                     zwx(ji,jj,jk) = zwx(ji,jj,jk) + p2dt(jk) * ( zwy(ji,jj,jk) - zwy(ji,jj,jk+1) ) * ze3tr
+                  END DO
                END DO
             END DO
+            !
          END DO
+
+         ! After tracer due to all trends
+         ! ------------------------------
+         IF( lk_vvl ) THEN          ! variable level thickness : leap-frog on tracer*e3t
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1 
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     ze3tb = fse3t_b(ji,jj,jk) / fse3t(ji,jj,jk)                          ! before e3t
+                     ztra  = zwx(ji,jj,jk) - ptrab(ji,jj,jk,jn) + p2dt(jk) * ptraa(ji,jj,jk,jn)       ! total trends * 2*rdt 
+                     ptraa(ji,jj,jk,jn) = ( ze3tb * ptrab(ji,jj,jk,jn) + ztra ) * tmask(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+         ELSE                       ! fixed level thickness : leap-frog on tracers
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1 
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     ptraa(ji,jj,jk,jn) = ( zwx(ji,jj,jk) + p2dt(jk) * ptraa(ji,jj,jk,jn) ) * tmask(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+         ENDIF
          !
       END DO
-
-      ! After tracer due to all trends
-      ! ------------------------------
-      IF( lk_vvl ) THEN          ! variable level thickness : leap-frog on tracer*e3t
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1 
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  ze3tb = fse3t_b(ji,jj,jk) / fse3t(ji,jj,jk)                          ! before e3t
-                  zta   = zwx(ji,jj,jk) - tb(ji,jj,jk) + p2dt(jk) * ta(ji,jj,jk)       ! total trends * 2*rdt
-                  zsa   = zwz(ji,jj,jk) - sb(ji,jj,jk) + p2dt(jk) * sa(ji,jj,jk)     
-                  ta(ji,jj,jk) = (  ze3tb * tb(ji,jj,jk) + zta  ) * tmask(ji,jj,jk)
-                  sa(ji,jj,jk) = (  ze3tb * sb(ji,jj,jk) + zsa  ) * tmask(ji,jj,jk)
-               END DO
-            END DO
-         END DO
-      ELSE                       ! fixed level thickness : leap-frog on tracers
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1 
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  ta(ji,jj,jk) = ( zwx(ji,jj,jk) + p2dt(jk) * ta(ji,jj,jk) ) * tmask(ji,jj,jk)
-                  sa(ji,jj,jk) = ( zwz(ji,jj,jk) + p2dt(jk) * sa(ji,jj,jk) ) * tmask(ji,jj,jk)
-               END DO
-            END DO
-         END DO
-      ENDIF
       !
    END SUBROUTINE tra_zdf_exp
